package com.yizhi.aliyun.application.controller;

import com.yizhi.aliyun.application.util.PropertiesUtil;
import com.yizhi.core.application.file.util.MinioTools;
import com.yizhi.util.application.domain.Response;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.servlet.support.ServletUriComponentsBuilder;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
 
@RestController
@RequestMapping("/api")
public class FileUploadController {

    @Autowired
    private MinioTools minioTools;

    @Autowired
    PropertiesUtil propertiesUtil;

    @Value("${pc.host.url}")
    String pcHostUrl;
 
    @PostMapping("/upload")
    public Response<String> uploadFile(@RequestParam("file") MultipartFile file,@RequestParam("Filename")String Filename) {
        try {
            String[] fileNames =  Filename.split("/");;
            String bucketName =fileNames[0];
            String name = fileNames[1];
            minioTools.uplodFile(bucketName,name,file.getInputStream());
            return Response.ok(pcHostUrl+"/api/v1/buckets/"+bucketName+"/objects/download/?preview=true&prefix="+name);
        } catch (IOException ex) {
            return Response.fail("Could not upload the file: " + Filename);
        }
    }
}